ideal
model tiny

dataseg
    usage db 'Pouit: ICOVIEW.COM ikona.ico', 13, 10, 'Textov prohle standardnch ikon Windows', 13, 10, 'Jakub Vrna, 1998, public domain', 13, 10, '$'
    error db 'Nen ikona Windows.', 13, 10, '$'
    ioerr db 'Chyba pi natn.', 13, 10, '$'
    handle dw ?                 ;rukoje souboru
    buf db 17 dup (?)           ;bufer na natn ze souboru a na prci s paletou
    buf2 db 4 dup (?)           ;bufer na natn ze souboru
    pal db 48 dup (?)           ;msto na uloen palety
    laced db 0                  ;pznak prokldn (0-ne, 1-lich dky, 2-sud dky)
    endx db ?                   ;vodorovn konec ikony
    endy db ?                   ;svisl konec ikony

codeseg
    startupcode
    mov bx, 80h                 ;pkazov dek
    add bl, [byte bx]           ; dlka vech parametr
    mov [byte bx+1], 0          ; za parametry d 0
    mov di, 80h                 ; zatek parametr - 1
@spaces:                        ;odstrann mezer na zatku pkazovho dku
    inc di
    cmp [byte di], ' '          ; dokud je na zatku mezera
    je  @spaces
    jmp @start

@usage:
    mov ah, 9                   ;vpis etzce
    mov dx, offset usage        ; ukazatel na prvn znak
    int 21h
    mov ax, 4c01h               ;ukoni program s nvratovm kdem 1
    int 21h
@error:
    mov ah, 9                   ;vpis etzce
    mov dx, offset error        ; ukazatel na prvn znak
    int 21h
    mov ax, 4c03h               ;ukoni program s nvratovm kdem 3
    int 21h
@ioerr:
    mov ah, 9                   ;vpis etzce
    mov dx, offset ioerr        ; ukazatel na prvn znak
    int 21h
    mov ax, 4c02h               ;ukoni program s nvratovm kdem 2
    int 21h

@start:
    mov ax, 3d00h               ;oteven souboru pro ten
    mov dx, di                  ; ukazatel na prvn parametr pkazovho dku
    int 21h
    jc  @usage                  ; nepodailo se otevt soubor
    mov [handle], ax            ; uloit rukoje souboru
    mov ax, 4202h               ;posun ukazatele od konce souboru
    mov bx, [handle]            ; rukoje souboru
    xor cx, cx                  ; na pln konec
    xor dx, dx
    int 21h
    jc  @ioerr                  ; pesun ukazatele nevyel
    cmp dx, 0
    jne @error                  ; moc dlouh soubor
    cmp ax, 766
    jne @error                  ; dlka souboru <> 766, nen standardn ikona
    mov ax, 4200h               ;posun ukazatele od zatku souboru
    mov dx, 62                  ; pesu se za hlaviku ikony
    int 21h
    jc  @ioerr                  ; pesun ukazatele nevyel

    mov ax, 1009h               ;naten vech registr palety
    push ds
    pop es
    mov dx, offset buf
    int 10h
    xor si, si                  ;nulovn pro cyklus palety
    mov di, offset pal
@palette:
    mov ah, 3fh                 ;ti ze souboru
    mov bx, [handle]            ; rukoje souboru
    mov cx, 4                   ; poet tench byt
    mov dx, offset buf2         ; adresa bufferu pro ten
    int 21h
    jc  @ioerr                  ; naten znak nevylo
    mov bl, [buf+si]            ;slo registru barvy
    xor bh, bh                  ; do bx
    mov ax, 1015h               ;uloen starch hodnot palety
    int 10h
    mov [di+2], dh              ; erven
    mov [di+1], ch              ; zelen
    mov [di], cl                ; modr
    mov ax, 1010h               ;nastaven barvy v palet
    mov dh, [buf2+2]            ; erven
    mov ch, [buf2+1]            ; zelen
    mov cl, [buf2]              ; modr
    shr cx, 1                   ; barvy mus bt v rozmez 0..63
    shr cx, 1
    shr dh, 1
    shr dh, 1
    int 10h
    add di, 3
    inc si                      ;dal barva
    cmp si, 16                  ; celkem jich je 16
    jl  @palette

    mov ax, 1003h               ;zkaz blikn textu
    mov bl, 0                   ; povolen intenzity
    int 10h
    mov ax, 0501h               ;nastav strnku na 1
    int 10h
    mov ax, 600h                ;sma obrazovku
    mov bh, 7                   ; atribut
    xor cx, cx                  ; lev horn roh
    mov es, cx                  ; oblast systmovch promnnch
    mov dh, [es:484h]           ; dek pravho spodnho rohu
    mov dl, [es:44ah]           ; sloupec pravho spodnho rohu
    dec dl                      ; v [0:44ah] je poet sloupc a ne maximln pozice
    int 10h

    mov dl, [es:44ah]           ;souadnice x pro vpis na obrazovku
    add dl, 32                  ; ka ikony
    shr dl, 1                   ; polovina
    mov [endx], dl              ; uloen do promnn
    mov dh, [es:484h]           ;souadnice y pro vpis na obrazovku
    inc dh                      ; v [0:484h] je o 1 byte mn
    add dh, 32                  ; vka ikony
    shr dh, 1                   ; polovina
    mov [endy], dh              ;konen souadnice y
    sub [endy], 32              ; je o vku ikony jinde
    cmp dh, 32                  ;je vka obrazovky dostaten?
    jge @rows                   ; kdyby nebyla, musm prokldat dky
    sub dh, 8                   ; odeten poloviny plky vky ikony na proklad
    mov [laced], 1              ; nastaven pznaku prokldn na lichou dku
    add [endy], 8               ; v prokldanm reimu je endy jen o polovinu vky ikony jinde

@rows:
    push dx
    mov ah, 3fh                 ;ti ze souboru
    mov bx, [handle]            ; rukoje souboru
    mov cx, 16                  ; poet tench byt
    mov dx, offset buf          ; adresa bufferu
    int 21h
    pop dx
    mov dl, [endx]              ;pvodn nastaven pozice x
    sub dl, 32                  ; je o ku ikony jinde ne konec
@columns:
    call charadr                ;vypoten adresy znaku
    xor ax, ax                  ;zpracovn natenho znaku
    mov al, dl                  ; pozice na obrazovce
    add al, 32                  ; ka ikony
    sub al, [endx]              ; pozice konce dku
    shr al, 1                   ; pracuji po dvou bytech
    add ax, offset buf          ; ofset bufferu
    mov si, ax
    mov bh, [si]                ;datov byte
    mov bl, bh                  ; v jednom byte jsou dv hodnoty
    and bh, 0f0h                ; horn tyi bity
    and bl, 0fh                 ; doln tyi bity
    push 0b800h                 ;segment videopamti
    pop es
    mov cl, 4                   ;pprava pro posuny
    cmp [laced], 1              ;prokldan reim
    je  @odd                    ; lich dky
    jl  @both                   ; neprokldan reim
    jmp @even                   ; sud dky

@lineend:
    add dl, 2                   ;naetl jsem dva pixely
    cmp dl, [endx]              ;dokud se nedostanu na konec dku
    jne @columns                ; opakovn pro sloupce
    cmp [laced], 0              ;neprokldan reim
    je  @linenext
    xor [laced], 3              ;proho pznak lichosti prokldanho dku
    cmp [laced], 2              ; kdy jse na sudm dku
    je  @rows                   ; neodetej y
@linenext:
    dec dh                      ;dky jsou uloeny odspodu
    cmp dh, [endy]              ;dokud neprojdu vechny dky
    je  @AND
    jmp @rows

@both:                          ;neprokldan reim
    shl bl, cl                  ; nastaven barvy pozad
    mov ax, bx                  ; inverzn barva poped a pozad
    not ax
    shr ah, cl
    shr al, cl
    or  bx, ax
    mov [es:di+1], bh
    mov [es:di+3], bl
    jmp @lineend
@odd:                           ;lich dky nebo neprokldan reim
    shl bl, cl                  ; nastaven barvy pozad
    mov [es:di+1], bh
    mov [es:di+3], bl
    jmp @lineend
@even:                          ;sud dky prokldanho reimu
    shr bh, cl                  ; nastaven barvy textu
    mov [byte es:di], ''
    or  [es:di+1], bh
    mov [byte es:di+2], ''
    or  [es:di+3], bl
    jmp @lineend

@AND:
    cmp [laced], 0
    jne @end
    mov dh, [endy]
    add dh, 32
@ANDrows:
    push dx
    mov ah, 3fh                 ;ti ze souboru
    mov bx, [handle]            ; rukoje souboru
    mov cx, 4                   ; poet tench byt
    mov dx, offset buf          ; adresa bufferu
    int 21h
    pop dx
    mov dl, [endx]              ;pvodn nastaven pozice x
    sub dl, 32                  ; je o ku ikony jinde ne konec
    mov ax, [word buf]
    mov bx, [word buf+2]
    push 0b800h
    pop es
@ANDcols:
    call charadr
    mov cx, ax
    and cx, 1
    jz  @ANDhalf
    mov [byte es:di], ''
@ANDhalf:
    mov cx, bx
    and cx, 1
    jz  @ANDafter
    mov [byte es:di+32], ''
@ANDafter:
    shr ax, 1
    shr bx, 1
    inc dl
    cmp dl, [endx]
    jl  @ANDcols
    dec dh
    cmp dh, [endy]
    jg  @ANDrows

@end:
    mov ah, 3eh                 ;zaven souboru
    mov bx, [handle]            ; rukoje
    int 21h
    push 0                      ;oblast systmovch promnnch
    pop es
    mov ah, 2                   ;nastav pozici kurzoru
    mov bh, [es:462h]           ; aktuln strnka
    mov dh, [es:484h]           ; posledn dek
    mov dl, 0                   ; prvn sloupec
    int 10h
    mov ah, 8                   ;ekej na znak
    int 21h
    cmp al, 0                   ; rozen ASCII kd?
    jne @exit
    int 21h
@exit:
    mov ax, 0500h               ;nastav strnku na 0
    int 10h
    mov ax, 1009h               ;naten vech registr palety
    push ds
    pop es
    mov dx, offset buf
    int 10h
    xor si, si                  ;nulovn pro paletu
    xor di, di
    xor bh, bh
@oldpalette:
    mov bl, [buf+si]            ;slo registru barvy
    mov ax, 1010h               ;nastaven barvy v palet
    mov dh, [pal+di+2]          ; erven
    mov ch, [pal+di+1]          ; zelen
    mov cl, [pal+di]            ; modr
    int 10h
    add di, 3
    inc si
    cmp si, 16
    jl  @oldpalette

    mov ax, 4c00h               ;ukoni program s nvratovm kdem 0
    int 21h

proc charadr near               ;pevede dh (dky) a dl (sloupce) na di (msto v pamti)
    push ax
    push cx
    push es
    xor cx, cx                  ;vpoet adresy znaku
    mov es, cx                  ; oblast systmovch promnnch
    mov al, [es:44ah]           ; ka obrazovky
    mul dh                      ; krt souadnice y
    mov cl, dl                  ; souadnice x
    add ax, cx                  ; piti x
    shl ax, 1                   ; na kad znak jsou dva byte
    add ax, [es:44eh]           ; ofset souasn strnky
    mov di, ax                  ; pro pstup k pamti
    pop es
    pop cx
    pop ax
    ret
endp

end
